SystemOrganization addCategory: #'OrionGenerator-Test'!

TestCase subclass: #ASGeneratorTest
	instanceVariableNames: 'aGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionGenerator-Test'!

!ASGeneratorTest methodsFor: 'running' stamp: 'AnneEtien 4/3/2013 17:09'!
setUp
	
	aGenerator := ASGenerator new.! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 18:02'!
testCodeForASSelector

	self assert: (aGenerator codeForASSelector: (aGenerator getPropertiesOf: FAMIXTestClass) first) equals: 'kindAS: aVersion
	^ self privateKind versionIn: aVersion'! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 18:02'!
testCodeForSelector

	self assert: (aGenerator codeForSelector: (aGenerator getPropertiesOf: FAMIXTestClass ) first) equals: 'kind
	^ self kindAS: self currentContext'! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 17:03'!
testCreateASClass
	
	|  anASClass nbClass |
	
	nbClass := Smalltalk allClasses size.
	
	anASClass := aGenerator createASClass: FAMIXTestClass.

	self assert: anASClass notNil.
	self assert: (anASClass name) equals: #ASTestClass.
	self assert: (anASClass traitComposition allTraits contains: [:each | each name = #TFAMIXTestClass]).
	self assert: (anASClass superclass) equals: FAMIXTestClass.
	self assert: Smalltalk allClasses size equals: nbClass + 1.
	
	anASClass removeFromSystem.
	(Smalltalk globals at: #TFAMIXTestClass) removeFromSystem.! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 17:04'!
testCreateASTrait
	
	|   aTrait nbTraits |

	nbTraits := Smalltalk allTraits size.

	aTrait := aGenerator createASTrait: FAMIXTestClass .
	
	self assert: aTrait notNil.
	self assert: (aTrait name) equals: #TFAMIXTestClass.
	self assert: Smalltalk allTraits size equals: (nbTraits + 1).
	self assert: aTrait selectors size equals: TMooseEntity selectors size.
	self assert: (aTrait traitComposition allTraits includes: TMooseEntity).
	
	aTrait removeFromSystem.! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 17:04'!
testCreateASTraitExisting
	
	|   aTrait nbMeth nbTraits |

	nbTraits := Trait allInstances size.
	nbMeth := TFAMIXClass selectors size.

	aTrait := aGenerator createASTrait: FAMIXClass .

	self assert: aTrait notNil.
	self assert: (aTrait name) equals: #TFAMIXClass.
	self assert: Trait allInstances size equals: nbTraits.
	self assert: aTrait selectors size equals: nbMeth.
	! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 17:04'!
testCreateClassName

	self assert: (aGenerator createClassName: FAMIXPackage ) equals: #ASPackage.
	! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 17:04'!
testCreateClassNameNotFamix

	self assert: (aGenerator createClassName: MooseEntity ) equals: #ASMooseEntity.
	! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 17:04'!
testCreateTraitName

	self assert: (aGenerator createTraitName: FAMIXPackage ) equals: #TFAMIXPackage.
	! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 17:04'!
testCreateTraitNameNotFamix

	self assert: (aGenerator createTraitName: MooseEntity ) equals: #TMooseEntity.
	! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 18:00'!
testGetPropertiesOf

	self assert: (aGenerator getPropertiesOf: FAMIXTestClass ) size  equals: 1
! !

!ASGeneratorTest methodsFor: 'tests' stamp: 'AnneEtien 4/3/2013 17:51'!
testGetPropertiesOfEmpty

	self assert: (aGenerator getPropertiesOf: Object) size  equals: 0
! !
